package com.gxwebsoft.house.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.house.service.ReservationService;
import com.gxwebsoft.house.entity.Reservation;
import com.gxwebsoft.house.param.ReservationParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 预约记录表控制器
 *
 * @author 科技小王子
 * @since 2023-08-03 18:23:43
 */
@Api(tags = "预约记录表管理")
@RestController
@RequestMapping("/api/house/reservation")
public class ReservationController extends BaseController {
    @Resource
    private ReservationService reservationService;

    @PreAuthorize("hasAuthority('house:reservation:list')")
    @OperationLog
    @ApiOperation("分页查询预约记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<Reservation>> page(ReservationParam param) {
        // 使用关联查询
        return success(reservationService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('house:reservation:list')")
    @OperationLog
    @ApiOperation("查询全部预约记录表")
    @GetMapping()
    public ApiResult<List<Reservation>> list(ReservationParam param) {
        // 使用关联查询
        return success(reservationService.listRel(param));
    }

    @PreAuthorize("hasAuthority('house:reservation:list')")
    @OperationLog
    @ApiOperation("根据id查询预约记录表")
    @GetMapping("/{id}")
    public ApiResult<Reservation> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(reservationService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('house:reservation:save')")
    @OperationLog
    @ApiOperation("添加预约记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Reservation reservation) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          reservation.setUserId(loginUser.getUserId());
        }
        if (reservationService.save(reservation)) {
            return success("提交成功");
        }
        return fail("提交失败");
    }

    @PreAuthorize("hasAuthority('house:reservation:update')")
    @OperationLog
    @ApiOperation("修改预约记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Reservation reservation) {
        if (reservationService.updateById(reservation)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('house:reservation:remove')")
    @OperationLog
    @ApiOperation("删除预约记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (reservationService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('house:reservation:save')")
    @OperationLog
    @ApiOperation("批量添加预约记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Reservation> list) {
        if (reservationService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('house:reservation:update')")
    @OperationLog
    @ApiOperation("批量修改预约记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Reservation> batchParam) {
        if (batchParam.update(reservationService, "log_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('house:reservation:remove')")
    @OperationLog
    @ApiOperation("批量删除预约记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (reservationService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
